# coding: utf-8

"""
    Arduino IoT Cloud API

     Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from iot_api_client import schemas  # noqa: F401


class ArduinoTemplatevariable(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    ArduinoTemplatevariable media type (default view)
    """


    class MetaOapg:
        required = {
            "variable_id",
            "thing_id",
            "name",
            "permission",
            "type",
        }
        
        class properties:
            name = schemas.StrSchema
            permission = schemas.StrSchema
            thing_id = schemas.StrSchema
            type = schemas.StrSchema
            variable_id = schemas.StrSchema
        
            @staticmethod
            def thing_timezone() -> typing.Type['ArduinoTimezone']:
                return ArduinoTimezone
            __annotations__ = {
                "name": name,
                "permission": permission,
                "thing_id": thing_id,
                "type": type,
                "variable_id": variable_id,
                "thing_timezone": thing_timezone,
            }
    
    variable_id: MetaOapg.properties.variable_id
    thing_id: MetaOapg.properties.thing_id
    name: MetaOapg.properties.name
    permission: MetaOapg.properties.permission
    type: MetaOapg.properties.type
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["permission"]) -> MetaOapg.properties.permission: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["thing_id"]) -> MetaOapg.properties.thing_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["variable_id"]) -> MetaOapg.properties.variable_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["thing_timezone"]) -> 'ArduinoTimezone': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["name", "permission", "thing_id", "type", "variable_id", "thing_timezone", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["permission"]) -> MetaOapg.properties.permission: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["thing_id"]) -> MetaOapg.properties.thing_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["variable_id"]) -> MetaOapg.properties.variable_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["thing_timezone"]) -> typing.Union['ArduinoTimezone', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["name", "permission", "thing_id", "type", "variable_id", "thing_timezone", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        variable_id: typing.Union[MetaOapg.properties.variable_id, str, ],
        thing_id: typing.Union[MetaOapg.properties.thing_id, str, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        permission: typing.Union[MetaOapg.properties.permission, str, ],
        type: typing.Union[MetaOapg.properties.type, str, ],
        thing_timezone: typing.Union['ArduinoTimezone', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ArduinoTemplatevariable':
        return super().__new__(
            cls,
            *_args,
            variable_id=variable_id,
            thing_id=thing_id,
            name=name,
            permission=permission,
            type=type,
            thing_timezone=thing_timezone,
            _configuration=_configuration,
            **kwargs,
        )

from iot_api_client.model.arduino_timezone import ArduinoTimezone
